# Lokalise Flutter SDK
<!-- 
This README describes the package. If you publish this package to pub.dev,
this README's contents appear on the landing page for your package.

For information about how to write a good package README, see the guide for
[writing package pages](https://dart.dev/guides/libraries/writing-package-pages). 

For general information about developing packages, see the Dart guide for
[creating packages](https://dart.dev/guides/libraries/create-library-packages)
and the Flutter guide for
[developing packages and plugins](https://flutter.dev/developing-packages). 
-->

This package provides [Over-the-Air translation updates](https://lokalise.com)

## Over-the-air translation updates

Update translations for your Flutter applications over the air. [Learn more](https://lokalise.com)

## Getting started

Initialize Lokalise SDK (`main.dart` file)

## Usage

<pre>
import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
<b>import 'package:lokalise_flutter_sdk/lokalise_flutter_sdk.dart';</b> // Import sdk package
import 'generated/l10n.dart';

void main() {
  <b>Lokalise.init('&lt;SDK_TOKEN&gt;', '&lt;PROJECT ID&gt;');</b> // Init sdk 
  <b>Lokalise.setPreRelease(true);</b> // Add this only if you want to use prereleases
  <!-- <b>Lokalise.setAppVersion('&lt;TRANS_VERSION&gt;');</b> // Add this only if you want to explicitly set the application version, or in cases when automatic detection is not possible (e.g. Flutter web apps) -->

  runApp(MaterialApp(
      onGenerateTitle: (context) => Tr.of(context).appTitle,
      localizationsDelegates: [
        Tr.delegate,
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate,
        GlobalCupertinoLocalizations.delegate,
      ],
      supportedLocales: Tr.delegate.supportedLocales,
      home: HomePage()));
}

class HomePage extends StatefulWidget {
  @override
  State&lt;StatefulWidget&gt; createState() => _HomePageState();
}

class _HomePageState extends State&lt;HomePage&gt; {
  bool _isLoading = true;

  @override
  void initState() {
    super.initState();

    <b>Lokalise.updateTranslations().then(</b> // Call 'updateTranslations' after localization delegates initialization
        <b>(response) => setState(() {
              _isLoading = false;
            }),
        onError: (error) => setState(() {
              _isLoading = false;
            }));</b>
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(title: Text(Tr.of(context).pageHomeTitle)),
        body: Center(
            child: _isLoading ? CircularProgressIndicator() : Column(children: &lt;Widget&gt;[Text(Tr.of(context).welcome)])));
  }
}
</pre>

## Additional information

Generate localization files

<pre>
To generate dart class for OTA service,
after the translation keys have been changed
use this command:

flutter pub run lokalise_flutter_sdk:tr

or this command once:
dart pub global activate lokalise_flutter_sdk

and use:
tr
</pre>
